USE [RBAC]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE [dbo].[SALES](
	[Sale_Id] [int] IDENTITY(1,1) NOT NULL,
	[Date] [date] NOT NULL DEFAULT GETDATE(),	
        [Price] [money] NOT NULL DEFAULT 0,	
	[ManufacturerName] [nvarchar](30) NOT NULL,	
	[Model] [nvarchar](30) NOT NULL,	
	[Colour] [nvarchar](30) NOT NULL,	
	[EngineSize] decimal(3,1) NOT NULL,
	[EnginePower] [int] NOT NULL,
        [FuelType] [nvarchar](10) NOT NULL,
	[LHD] [bit] NOT NULL default 0,	
 CONSTRAINT [PK_SALES] PRIMARY KEY CLUSTERED 
(
	[Sale_Id] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Audi', 'A4', 'Black', 2.0, 29200, '2015-02-06', 'Diesel', 134) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Audi', 'A4', 'Black', 2.0, 32150, '2015-02-15', 'Diesel', 175) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Audi', 'A6', 'White', 3.0, 38950, '2015-02-28', 'Diesel', 215) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Audi', 'A4', 'Silver', 2.0, 32900, '2015-02-25', 'Diesel', 175) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Audi', 'A4', 'Red', 2.0, 29450, '2015-02-18', 'Diesel', 134) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Audi', 'A4', 'Red', 2.0, 29600, '2015-03-21', 'Diesel', 134) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Audi', 'A6', 'Black', 2.0, 34250, '2015-04-01', 'Diesel', 175) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Audi', 'A6', 'Blue', 3.0, 38800, '2015-04-29', 'Diesel', 215)
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Audi', 'RS6', 'Blue', 5.0, 78950, '2015-05-28', 'Petrol', 572) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Audi', 'A4', 'White', 2.0, 29850, '2015-06-07', 'Diesel', 134) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Audi', 'A4', 'Silver', 2.0, 32200, '2015-06-16', 'Diesel', 175) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Audi', 'RS4', 'Black', 4.2, 64975, '2015-06-28', 'Petrol', 444)
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Passat', 'Black', 2.0, 22950, '2015-08-23', 'Diesel', 170) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Passat', 'Black', 2.0, 21950, '2015-08-12', 'Diesel', 138) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Passat', 'Blue', 1.6, 20985, '2015-09-08', 'Diesel', 103) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Passat', 'White', 1.6, 21585, '2015-09-26', 'Diesel', 103) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Passat', 'White', 1.6, 22585, '2015-09-02', 'Diesel', 103) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Passat', 'Blue', 1.6, 21950, '2015-09-06', 'Diesel', 103) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Passat', 'Red', 1.6, 21985, '2015-09-12', 'Diesel', 103) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Passat', 'White', 1.6, 23185, '2015-09-18', 'Diesel', 103) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Passat', 'Red', 2.0, 19585, '2015-09-26', 'Diesel', 170) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Passat', 'Silver', 1.9, 15585, '2015-09-12', 'Diesel', 105) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Phaeton', 'Silver', 3.0, 58975, '2015-10-23', 'Diesel', 237)
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Golf', 'Red', 1.6, 16995, '2015-08-23', 'Diesel', 104) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Golf', 'Silver', 1.6, 17550, '2015-08-06', 'Diesel', 104) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'e-Golf', 'Blue', 0, 24395, '2015-08-06', 'Electric', 115)
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'e-Golf', 'Blue', 0, 25100, '2015-08-16', 'Electric', 115) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'e-Golf', 'Silver', 0, 24195, '2015-08-18', 'Electric', 115) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'e-Golf', 'Red', 0, 24890, '2015-08-22', 'Electric', 115) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Golf', 'White', 2.0, 27950, '2015-11-28', 'Diesel', 181) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Golf R32', 'Red', 3.2, 37950, '2015-11-28', 'Petrol', 280) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Tiguan', 'Silver', 1.4, 19950, '2015-09-21', 'Petrol', 148) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Tiguan', 'Blue', 1.4, 19450, '2015-09-01', 'Petrol', 148) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Tiguan', 'Blue', 1.4, 19850, '2015-09-02', 'Petrol', 148) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Tiguan', 'Blue', 2.0, 21875, '2015-09-25', 'Diesel', 138) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'Touareg', 'Grey', 3.0, 32995, '2015-12-25', 'Hybrid', 328) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'UP', 'White', 0, 16995, '2015-07-25', 'Electric', 80) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'UP', 'Red', 0, 16550, '2015-07-15', 'Electric', 80) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'UP', 'Silver', 0, 16995, '2015-07-12', 'Electric', 80) 
INSERT INTO SALES(ManufacturerName, Model, Colour, EngineSize, Price, Date, FuelType, EnginePower) VALUES('Volkswagen', 'UP', 'Silver', 0, 16895, '2015-07-14', 'Electric', 80) 


GO

CREATE PROCEDURE [dbo].[spTest]
	@Manufacturer VARCHAR(30) = null,
	@Model VARCHAR(30) = null,
	@fromSaleDate VARCHAR (19) = null,
	@toSaleDate VARCHAR (19) = null	
    AS
    BEGIN

	DECLARE @SQL varchar(1000) 
	SET @SQL = 'SELECT ManufacturerName, Model, CAST(EngineSize AS decimal(10,1)) AS [EngineSize], EnginePower, FuelType, DATENAME(Month, DATEADD(Month, DATEPART(Month, Date), 0) - 1) AS [Month], SUM(Price) AS [Total Sales], COUNT(*) AS [Total Orders] FROM [SALES] '

	IF (@Manufacturer IS NOT NULL AND @Manufacturer != '') OR (@Model IS NOT NULL AND @Model != '') OR (@fromSaleDate IS NOT NULL) OR (@toSaleDate IS NOT NULL)
		SET @SQL = @SQL + 'WHERE ' 

	IF @Manufacturer IS NOT NULL AND @Manufacturer != '' 
		SET @SQL = @SQL + 'ManufacturerName = ' + '''' + @Manufacturer + ''''


	IF @Model IS NOT NULL AND @Model != '' 
		SET @SQL = @SQL + 'Model = ' + '''' + @Model + ''''

	IF @fromSaleDate IS NOT NULL
		SET @SQL = @SQL + ' AND [Date] >= ' + '''' + @fromSaleDate + ''''

	IF @toSaleDate IS NOT NULL 
		SET @SQL = @SQL + ' AND [Date] <= ' + '''' +  @toSaleDate + ''''

	SET @SQL = @SQL + 'GROUP BY DATEPART(m, Date), ManufacturerName, Model, EngineSize, EnginePower, FuelType '
	SET @SQL = @SQL + 'ORDER BY ManufacturerName, Model, DATEPART(m, Date), EngineSize, EnginePower, FuelType'

	EXEC(@SQL)
    
    END

GO


--Create Report
INSERT INTO REPORTS VALUES(GETDATE(),0,'Sales Summary Report','This report details each transaction for each environment which can be filtered by ActionType and/or Environment for specific dates','customSalesSummary','spTest')
GO


INSERT INTO PARAMETERS VALUES('Manufacturer','String','Manufacturer', 1)
INSERT INTO PARAMETERS VALUES('Model','String','Model', 0)
INSERT INTO PARAMETERS VALUES('fromSaleDate','Date','Sale Date (From)', 0)
INSERT INTO PARAMETERS VALUES('toSaleDate','Date','Sale Date (To)', 0)
GO

INSERT INTO LNK_REPORT_PARAMETER VALUES((SELECT DISTINCT(Report_Id) FROM REPORTS WHERE ReportName = 'Sales Summary Report'),(SELECT DISTINCT(Parameter_Id) FROM PARAMETERS WHERE ParameterName = 'Manufacturer')) 
INSERT INTO LNK_REPORT_PARAMETER VALUES((SELECT DISTINCT(Report_Id) FROM REPORTS WHERE ReportName = 'Sales Summary Report'),(SELECT DISTINCT(Parameter_Id) FROM PARAMETERS WHERE ParameterName = 'Model')) 
INSERT INTO LNK_REPORT_PARAMETER VALUES((SELECT DISTINCT(Report_Id) FROM REPORTS WHERE ReportName = 'Sales Summary Report'),(SELECT DISTINCT(Parameter_Id) FROM PARAMETERS WHERE ParameterName = 'fromSaleDate')) 
INSERT INTO LNK_REPORT_PARAMETER VALUES((SELECT DISTINCT(Report_Id) FROM REPORTS WHERE ReportName = 'Sales Summary Report'),(SELECT DISTINCT(Parameter_Id) FROM PARAMETERS WHERE ParameterName = 'toSaleDate'))
GO 


--Associate the Report with 'Administrator' Role
INSERT INTO LNK_ROLE_REPORT VALUES(
	(SELECT DISTINCT(Role_Id) FROM ROLES WHERE RoleName = 'Administrator'),
	(SELECT DISTINCT(Report_Id) FROM REPORTS WHERE ReportName = 'Sales Summary Report'))