USE [RBAC]
GO


SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

--Create REPORTS table...
CREATE TABLE [dbo].[REPORTS](
	[Report_Id] [int] IDENTITY(1,1) NOT NULL,
	[LastModified] [datetime] NOT NULL,
	[Inactive] [bit] NOT NULL,
	[ReportName] [nvarchar](150) NOT NULL,
	[ReportDescription] [nvarchar](max) NULL,
	[Template] [nvarchar](50) NULL,
	[StoredProcedureName] [nvarchar](50) NULL,
 CONSTRAINT [PK_REPORTS] PRIMARY KEY CLUSTERED 
(
	[Report_Id] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

ALTER TABLE [dbo].[REPORTS] ADD  CONSTRAINT [DF_REPORTS_LASTMODIFIED]  DEFAULT (getdate()) FOR [LastModified]
GO

ALTER TABLE [dbo].[REPORTS] ADD  DEFAULT ((0)) FOR [Inactive]
GO

--Create LNK_ROLE_REPORT table...
CREATE TABLE [dbo].[LNK_ROLE_REPORT](
	[Role_Id] [int] NOT NULL,
	[Report_Id] [int] NOT NULL,
 CONSTRAINT [PK_LNK_ROLE_REPORT] PRIMARY KEY CLUSTERED 
(
	[Role_Id] ASC,
	[Report_Id] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

ALTER TABLE [dbo].[LNK_ROLE_REPORT]  WITH NOCHECK ADD  CONSTRAINT [FK_LNK_ROLE_REPORT_REPORTS] FOREIGN KEY([Report_Id])
REFERENCES [dbo].[REPORTS] ([Report_Id])
GO

ALTER TABLE [dbo].[LNK_ROLE_REPORT] CHECK CONSTRAINT [FK_LNK_ROLE_REPORT_REPORTS]
GO

ALTER TABLE [dbo].[LNK_ROLE_REPORT]  WITH NOCHECK ADD  CONSTRAINT [FK_LNK_ROLE_REPORT_ROLES] FOREIGN KEY([Role_Id])
REFERENCES [dbo].[ROLES] ([Role_Id])
GO

ALTER TABLE [dbo].[LNK_ROLE_REPORT] CHECK CONSTRAINT [FK_LNK_ROLE_REPORT_ROLES]
GO

--Create PARAMETERS table...
CREATE TABLE [dbo].[PARAMETERS](
	[Parameter_Id] [int] IDENTITY(1,1) NOT NULL,
	[ParameterName] [nvarchar](30) NOT NULL,
	[ParameterType] [nvarchar](50) NULL,
	[DisplayLabel] [nvarchar](50) NULL,		
	[Required] [bit] NULL	
 CONSTRAINT [PK_PARAMETERS] PRIMARY KEY CLUSTERED 
(
	[Parameter_Id] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

--Create LNK_REPORT_FILTER table...
CREATE TABLE [dbo].[LNK_REPORT_PARAMETER](
	[Report_Id] [int] NOT NULL,
	[Parameter_Id] [int] NOT NULL,
 CONSTRAINT [PK_LNK_REPORT_PARAMETER] PRIMARY KEY CLUSTERED 
(
	[Report_Id] ASC,
	[Parameter_Id] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

ALTER TABLE [dbo].[LNK_REPORT_PARAMETER]  WITH NOCHECK ADD  CONSTRAINT [FK_LNK_REPORT_PARAMETER_REPORTS] FOREIGN KEY([Report_Id])
REFERENCES [dbo].[REPORTS] ([Report_Id])
GO

ALTER TABLE [dbo].[LNK_REPORT_PARAMETER] CHECK CONSTRAINT [FK_LNK_REPORT_PARAMETER_REPORTS]
GO

ALTER TABLE [dbo].[LNK_REPORT_PARAMETER]  WITH NOCHECK ADD  CONSTRAINT [FK_LNK_REPORT_PARAMETER_PARAMETERS] FOREIGN KEY([Parameter_Id])
REFERENCES [dbo].[PARAMETERS] ([Parameter_Id])
GO

ALTER TABLE [dbo].[LNK_REPORT_PARAMETER] CHECK CONSTRAINT [FK_LNK_REPORT_PARAMETER_PARAMETERS]
GO